Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0008384opensim[REGION] Physics Enginespublic2018-10-01 18:102018-10-06 10:52
ReporterClinton 
Assigned To 
PriorityurgentSeveritymajorReproducibilityalways
StatusnewResolutionopen 
PlatformWindows 7OSOS Version
Product Version0.9.0.1 
Target VersionFixed in Version 
Summary0008384: BulletSim: Avatar can't move and is stuck in falling animation
DescriptionOn OSGrid using Bullet Physics my avatar is stuck in the falling animation if there is any mesh on any region in the instance and I am standing on land. If I'm on a prim, everything is OK until you step off onto land.

My standalone using ubODE is fine. If I change to Bullet, same thing happens.
Steps To ReproduceUse Bullet Physics with Mesh on a region.
TagsNo tags attached.
Git Revision or version numberOSgrid 0.9.1.0 Snail Dev 57ae99b113: 2018-09-30
Run Mode Grid (Multiple Regions per Sim)
Physics EngineBulletSim
Environment.NET / Windows64
Mono VersionNone
ViewerCool VL Viewer and Singul
Attached Files

- Relationships

-  Notes
(0033107)
aiaustin (developer)
2018-10-02 07:13
edited on: 2018-10-02 07:30

This is also happening to me with the 30-Sep-2018 OSGrid region addon download on Windows 10 servers... several different ones of different vintages. All using default BulletSim physics. And on simple regions with pimple island terrain that I think has prims only as well as other more complex regions. ALL regions I tried after the update. Using Firestorm 5.1.7.55786 (64bit Windows).
Problem goes away if I revert to the 15-Sep-2018 OSGrid download with identical .ini file configuration.

Dan Banner at OSGrid is aware and investigating. He asked me for the "config show BulletSim" and this for both 15-Sep-2018 and 30-Sep-2018 versions looks identical...

[BulletSim]
  BulletEngine = bulletunmanaged
  UseSeparatePhysicsThread = true
  TerrainImplementation = 0
  TerrainMeshMagnification = 2
  AvatarToAvatarCollisionsByDefault = true
  AvatarHeightLowFudge = 0
  AvatarHeightMidFudge = 0
  AvatarHeightHighFudge = 0
  AvatarTerminalVelocity = -54
  LinkImplementation = 1
  LinksetOffsetCenterOfMass = false
  MeshSculptedPrim = true
  ForceSimplePrimMeshing = false
  ShouldRemoveZeroWidthTriangles = true
  ShouldUseAssetHulls = true
  MaxCollisionsPerFrame = 2048
  MaxUpdatesPerFrame = 8192
  PhysicsLoggingEnabled = False
  PhysicsLoggingDir = .
  VehicleLoggingEnabled = False

This appears to be related to interaction between the avatar (or NPCs) and terrain... not when over prims or objects.

If I adjust the terrain with a smooth or something like that, even minimally, the issue goes away. But, even after a backup to persist the change, after restarting the region server it comes back.

(0033108)
aiaustin (developer)
2018-10-02 07:37
edited on: 2018-10-02 07:40

I have pinned this down to an issue introduced between opensim-0.9.0.1-456-g5a0c9c2.zip (2018-09-27 18:04) and opensim-0.9.0.1-462-g57ae99b.zip (2018-09-30 04:39).

opensim-0.9.0.1-456-g5a0c9c2.zip appears to work correctly on my grids. opensim-0.9.0.1-462-g57ae99b.zip shows the falling avatar animation behaviour when the avatar (or an NPC) is "on" or near the terrain.

Its not specifically related to OSGrid which recently updated to opensim-0.9.0.1-462-g57ae99b.zip 2018-09-20 04:39.

(0033109)
aiaustin (developer)
2018-10-02 08:24

Problem is introduced by opensim-0.9.0.1-457-ged0e262.zip (2018-09-29 16:42) which incorporates some Garbage Collection changes.

The previous version opensim-0.9.0.1-456-g5a0c9c2.zip (2018-09-27 18:04) works, all after that cause the falling avatar issue in interaction with the terrain.
(0033110)
FreakyTech (reporter)
2018-10-03 03:44
edited on: 2018-10-03 03:44

Not wondering since the higher amount of GC calls is more often triggering a GC run and BulletSim's native code interfacing is prone to GC concurrency issues based upon incomplete object reference graphs. This results into wrong order memory releases and therefore triggers all sorts of such error messages including invalid virtual function call pointers.

(0033111)
UbitUmarov (administrator)
2018-10-03 08:14

No isn't a higher amount of gc collects on normal regions execution. Only one was added at region ready.
A few others where added on large oar saves, since there are reports on gc never releasing several GB of ram in that case.

I just tested and can't reproduce the issue
I am using .net4.7.2 and you ?
(0033112)
UbitUmarov (administrator)
2018-10-03 08:25

Please test with
UseSeparatePhysicsThread = false
(0033113)
watcher64 (reporter)
2018-10-03 09:28

I tried to repro this on linux and could not ...
(0033114)
Clinton (reporter)
2018-10-03 10:20

I'm using .net4.7.2. Changing UseSeparatePhysicsThread to false didn't help on my standalone.

It doesn't happen unless you have a mesh object on your sim. Mesh on any 1 region in an instance will effect all regions in the instance.
(0033115)
watcher64 (reporter)
2018-10-03 11:00
edited on: 2018-10-03 11:04

just for giggles , try

TerrainImplementation = 1

I was able to repro it on my windows box , and setting that "fixed" it.
that is only on single region ... does not work on vars of course ..

(0033116)
aiaustin (developer)
2018-10-03 11:36

Travelling for rest of the week and away from servers, but please remind me of the best way to establish the .net version actually in use for the compile. Is it reported while doing runprebuild.bat and/or compile or do I need to find it another way.
(0033117)
Clinton (reporter)
2018-10-03 11:56

Yes, TerrainImplementation = 1 "fixes" it.
(0033118)
UbitUmarov (administrator)
2018-10-03 12:54
edited on: 2018-10-03 12:57

Var regions do as terrainimplementation = 0, because 1 is just too heavy. So not a usable "fix"

I think I traced the issue to a problem on managed/unmanaged memory sharing on bullet height maps, that was there just waiting to show up.

(0033119)
aiaustin (developer)
2018-10-03 12:56
edited on: 2018-10-03 12:59

@Freakytech mentioned something interesting in the context of this issue... about invalid virtual function call pointers.

Interesting, as I am getting that in a windows pop up crash error (or a set of red bulletsim errors followed by a crash sometimes) with one mesh rich BulletSim region on one of my grids on shutdown and that was not happening before. It is though occurring with the OpenSim dev code BEFORE the GC changes commit we are talking about here.

See http://opensimulator.org/mantis/view.php?id=8385 [^]

I.e. with opensim-0.9.0.1-456-g5a0c9c2.zip (2018-09-27 18:04)

(0033120)
UbitUmarov (administrator)
2018-10-03 13:32

I made a change on bullet, trying to fix the issue. I can't test it, because I still can't get the issue.

Bill had seen the issue and seems this code does fix this issue.

Thanks Bill

Lets hope Bullet does not have more cases other than heightmaps :(
(0033121)
watcher64 (reporter)
2018-10-03 13:52
edited on: 2018-10-03 13:52

With testing this new build, the issue seems to be gone, can no longer replicate on my windows instance ..

Thanks Ubit

aka Bill Blight

(0033122)
aiaustin (developer)
2018-10-04 02:17

Tested by updating AiLand grid and region addon servers to opensim-0.9.0.1-463-g1bcdcc2.zip (2018-10-03 20:17) and the falling avatar near terrain issue now seems to be fixed @Ubit. Many thanks.
(0033124)
aiaustin (developer)
2018-10-04 10:59
edited on: 2018-10-04 10:59

I used regedit on Computer\HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\.NETFramework\v4.0.30319\SKUs
to look for installed SKUs for .net and it shows up to 4.7.2. But the runbuild and compile show this as the root for the build as far as I can see...

C:\Windows\Microsoft.NET\Framework64\v4.0.30319\

This appears to be the root registry key for ALL the .net 4 SKUs installed. Is that what we expect?

(0033126)
Clinton (reporter)
2018-10-06 07:33

That fixed it. Thanks.
(0033127)
UbitUmarov (administrator)
2018-10-06 10:52

Yes AiAustin, I see the same here
4.7.2 is a 4.x version, different components of it, like the runtime, follow other version numbers rules

- Issue History
Date Modified Username Field Change
2018-10-01 18:10 Clinton New Issue
2018-10-02 07:13 aiaustin Note Added: 0033107
2018-10-02 07:16 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:16 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:16 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:17 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:17 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:19 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:20 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:23 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:30 aiaustin Note Edited: 0033107 View Revisions
2018-10-02 07:37 aiaustin Note Added: 0033108
2018-10-02 07:38 aiaustin Note Edited: 0033108 View Revisions
2018-10-02 07:40 aiaustin Note Edited: 0033108 View Revisions
2018-10-02 07:42 aiaustin Priority normal => urgent
2018-10-02 08:24 aiaustin Note Added: 0033109
2018-10-03 03:44 FreakyTech Note Added: 0033110
2018-10-03 03:44 FreakyTech Note Edited: 0033110 View Revisions
2018-10-03 08:14 UbitUmarov Note Added: 0033111
2018-10-03 08:25 UbitUmarov Note Added: 0033112
2018-10-03 09:28 watcher64 Note Added: 0033113
2018-10-03 10:20 Clinton Note Added: 0033114
2018-10-03 11:00 watcher64 Note Added: 0033115
2018-10-03 11:04 watcher64 Note Edited: 0033115 View Revisions
2018-10-03 11:36 aiaustin Note Added: 0033116
2018-10-03 11:56 Clinton Note Added: 0033117
2018-10-03 12:54 UbitUmarov Note Added: 0033118
2018-10-03 12:56 aiaustin Note Added: 0033119
2018-10-03 12:57 aiaustin Note Edited: 0033119 View Revisions
2018-10-03 12:57 aiaustin Note Edited: 0033118 View Revisions
2018-10-03 12:59 aiaustin Note Edited: 0033119 View Revisions
2018-10-03 13:32 UbitUmarov Note Added: 0033120
2018-10-03 13:52 watcher64 Note Added: 0033121
2018-10-03 13:52 watcher64 Note Edited: 0033121 View Revisions
2018-10-04 02:17 aiaustin Note Added: 0033122
2018-10-04 10:59 aiaustin Note Added: 0033124
2018-10-04 10:59 aiaustin Note Edited: 0033124 View Revisions
2018-10-05 08:10 aiaustin Summary Avatar can't move and is stuck in falling animation => BulletSim: Avatar can't move and is stuck in falling animation
2018-10-05 08:11 aiaustin Relationship added related to 0008385
2018-10-05 08:12 aiaustin Relationship deleted related to 0008385
2018-10-06 07:33 Clinton Note Added: 0033126
2018-10-06 10:52 UbitUmarov Note Added: 0033127


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker